﻿/*
 * Created by SharpDevelop.
 * User: munet
 * Date: 2005/10/27
 * Time: 21:26
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;

namespace Mumed {	
	/// <summary>実数・虚数・例外を管理する数字クラス</summary>
	public class MCalc : ICloneable {

		private bool  ex;   // 例外が発生したか？
		private MNum  r;    // 実数領域
		private MNum  i;    // 虚数領域
		
        /// <summary>初期化コンストラクタ</summary>
		public MCalc() {
			this.ex = true;
			this.r  = new MNum("0");
			this.i  = new MNum("0");
		}

        /// <summary>初期化コンストラクタ←string</summary>
        public MCalc(string x) : this() {
        	// 複素数判定
        	if ( x.IndexOf('i') >= 0) {
				// 単項ｉ
				Regex r_tImage = new Regex(@"^(-?)([0-9\./]*)i$");
				string[] s_tImage = r_tImage.Split(x);

				/*
	            StringBuilder saa = new StringBuilder();
	            saa.Append(s_tImage.Length);
	            saa.Append("\n");
	            for (int i = 0; i < s_tImage.Length; i++) {
	            	saa.Append(i);
	            	saa.Append(" : ");
	            	saa.Append(s_tImage[i]);
		            saa.Append("\n");
	            }
				System.Windows.Forms.MessageBox.Show(saa.ToString());
				*/

				if (s_tImage.Length == 4) {
					StringBuilder sb = new StringBuilder();
					if (s_tImage[1].Equals("-")) sb.Append('-');
					if (s_tImage[2].Length > 0) sb.Append(s_tImage[2]);
					else sb.Append('1');
					this.i = new MNum(sb.ToString());
				} else {
					// なにか±なにかｉ
		            Regex r_sImage = new Regex(@"^(-?)([0-9\./]*)([/+/-])([0-9\./]*)i$");
		            string[] s_sImage = r_sImage.Split(x);
	
		            if (s_sImage.Length == 6) {
						string sr = s_sImage[1].Equals("-") ? "-" + s_sImage[2] : s_sImage[2];
		            	this.r = new MNum(sr);
						StringBuilder sb = new StringBuilder();
						if (s_sImage[3].Equals("-")) sb.Append('-');
						if (s_sImage[4].Length > 0) sb.Append(s_sImage[4]);
						else sb.Append('1');
						this.i = new MNum(sb.ToString());
					}
				}
            } else {
	        	this.r = new MNum(x);
            }
		}

        /// <summary>ToString</summary>
        /// <returns>String化されたMCalcデータ</returns>
		public override string ToString() {
			StringBuilder sb = new StringBuilder();
			sb.Append(";Value : ");
			
			if (this.IsImage()) {
				if (!this.r.isZero()) {
					sb.Append(this.r.ToString());
					if (this.i.sign) sb.Append("+");
				}
				if (!this.i.isOne()) {
					sb.Append(this.i.ToString());
				} else {
					if (this.i.isMinus()) sb.Append('-');
				}
				sb.Append("i");
			} else {
				sb.Append(this.r.ToString());
			}
			return sb.ToString();
		}

        /// <summary>Clone</summary>
        /// <returns>複製されたMCalcオブジェクト</returns>
        public object Clone() {
            MCalc C = new MCalc();
            C.ex   = this.ex;
            C.r    = (MNum)this.r.Clone();
            C.i    = (MNum)this.i.Clone();
            return C;
        }

        /// <summary>
        /// MCalc用文字列分割
        /// スペースで分割するが、半角括弧で囲まれているものは分割しない。
        /// </summary>
        /// <param name="s">分割したい文字列</param>
        /// <returns>分割後の文字列</returns>
        public static string[] XSplit(string s) {
            ArrayList al = new ArrayList();
            string s_tmp = "";
            int r = 0;
            for (int i = 0; i < s.Length; i++) {
                if (s[i] == ' ' && r == 0) {
                    if (s_tmp.Length > 0) {
                        al.Add(s_tmp);
                        s_tmp = "";
                    }
                    continue;
                }
                if (s[i] == '(') r++;
                if (s[i] == ')') r--;
                s_tmp += s[i];
            }
            if (s_tmp.Length > 0) al.Add(s_tmp);

            return (string[])al.ToArray(typeof(string));
        }

        /// <summary>Lisp解析</summary>
        /// <param name="s">Lisp解析対象の文字列</param>
        /// <returns>解析結果の答え</returns>
        public static MCalc AnalysisLisp(string s) {

            /* 括弧があるかどうかを検査 */
            s.Trim();
            int l_parenthesis = s.IndexOf('(');
            int r_parenthesis = s.LastIndexOf(')');
            //MessageBox.Show("l = " + l_parenthesis + ", r = " + r_parenthesis);
            if (l_parenthesis == 0 && l_parenthesis < r_parenthesis) {
                int s_length = r_parenthesis - ++l_parenthesis;
                string s_newtext = s.Substring(l_parenthesis, s_length).Trim();
                // 処理対象文字列
                //MessageBox.Show(s_newtext);
                return AnalysisLisp(s_newtext);
            }

            /* 単一の値かどうかをチェック */
            string[] sp = XSplit(s);
            // 処理対象文字列
            //StringBuilder sab = new StringBuilder();
            //for(int i = 0; i < sp.Length; i++) sab.Append(i.ToString() + " : " + sp[i] + "\n");
            //System.Windows.Forms.MessageBox.Show(sab.ToString());

            if (sp.Length == 1) {
                MCalc MI = new MCalc();
                try {
                    MI = new MCalc(sp[0]);
                } catch (Exception ex) {
                    System.Windows.Forms.MessageBox.Show("0001 \n" + ex.Message);
                    MI.Excepted();
                }
                return MI;
            } else {
                MCalc MI = new MCalc();
                try {
                    MI = AnalysisLisp(sp[1]);
                    MCalc MX;

                    switch (sp[0]) {
                        /* 加算 */
                        case "+":
                            for (int i = 2; i < sp.Length; i++) {
                                MX = AnalysisLisp(sp[i]);
                                MI.Add(MX);
                            }
                            break;
                        /* 減算 */
                        case "-":
                            for (int i = 2; i < sp.Length; i++) {
                                MX = AnalysisLisp(sp[i]);
                                MI.Sub(MX);
                            }
                            break;
                        /* 乗算 */
                        case "*":
                            for (int i = 2; i < sp.Length; i++) {
                                MX = AnalysisLisp(sp[i]);
                                MI.Mul(MX);
                            }
                            break;
                        /* 除算 */
                        case "/":
                            for (int i = 2; i < sp.Length; i++) {
                                MX = AnalysisLisp(sp[i]);
                                MI.Div(MX);
                            }
                            break;
                        /* 商 */
                        case "\\":
                            for (int i = 2; i < sp.Length; i++) {
                                MX = AnalysisLisp(sp[i]);
                                MI.Quo(MX);
                            }
                            break;
                        /* 剰余 */
                        case "%":
                            MX = AnalysisLisp(sp[2]);
                            MI.Mod(MX);
                            break;
                        /* 正弦 */
                        case "sin":
                            MI.Tri(TriDef.Sin);
                            break;
                        /* 余弦 */
                        case "cos":
                            MI.Tri(TriDef.Cos);
                            break;
                        /* 正接 */
                        case "tan":
                            MI.Tri(TriDef.Tan);
                            break;
                        /* 正弦の逆関数 */
                        case "asin":
                            MI.Tri(TriDef.Asin);
                            break;
                        /* 余弦の逆関数 */
                        case "acos":
                            MI.Tri(TriDef.Acos);
                            break;
                        /* 正接の逆関数 */
                        case "atan":
                            MI.Tri(TriDef.Atan);
                            break;
                        /* 双曲正弦 */
                        case "sinh":
                            MI.Tri(TriDef.Sinh);
                            break;
                        /* 双曲余弦 */
                        case "cosh":
                            MI.Tri(TriDef.Cosh);
                            break;
                        /* 双曲正接 */
                        case "tanh":
                            MI.Tri(TriDef.Tanh);
                            break;
                        /* 自然対数 */
                        case "ln":
                        	MI.Log();
                            break;
                        /* 対数（汎用） */
                        case "log":
	                        if (sp.Length == 2) {
	                        	MX = new MCalc("10.0");
	                        	MI.Log(MX);
	                        } else {
			                    MX = AnalysisLisp(sp[2]);
			                    MI.Log(MX);
	                        }
                            break;
                        /* 超えない整数 */
                        case "floor":
                            MI.Floor();
                            break;
                        /* 絶対値 */
                        case "abs":
                            MI.Abs();
                            break;
                        /* 三角数 */
                        case "tri":
                            MX = (MCalc)MI.Clone();
                            MX.Add(new MCalc("1"));
                            MI.Mul(MX);
                            MI.Div(new MCalc("2"));
                            break;
                        /* 四角数 */
                        case "rect":
                        case "square":
                            MX = (MCalc)MI.Clone();
                            MI.Mul(MX);
                            break;
                        /* 三乗 */
                        case "cube":
                            MX = (MCalc)MI.Clone();
                            MI.Mul(MX);
                            MI.Mul(MX);
                            break;
                    }
                    /* べき乗
                    if (sp[0].Equals("power")) {
                        MCalc MX = Analysis_Text(sp[2]);
                        MCalc MY = Analysis_Text(sp[1]);
                        int j = MX.GetData();
                        if ( j > 0 ) for ( int i = 1; i < j; i++ ) MI.Mul(MY);
                        if ( j < 0 ) for ( int i = 0; i > j; i-- ) MI.Div(MY);
                        if ( j == 0 ) MI.SetData(1);
                    } */
                } catch (Exception ex) {
                    StringBuilder sb = new StringBuilder();
                    for (int i = 0; i < sp.Length; i++) {
                        sb.Append(sp[i]);
                        sb.Append("\n");
                    }
                    System.Windows.Forms.MessageBox.Show("0002 : Analyse Error \n" + ex.Message);
                    //System.Windows.Forms.MessageBox.Show("0002 \n" + ex.Message + "\n" + sb.ToString());
                    MI.Excepted();
                }
                return MI;
            }
        }

        /***********************************************/
        /***********************************************/
        /***********************************************/
        
        /// <summary>例外発生</summary>
		public void Excepted(){
			this.ex = false;
		}
		/// <summary>正常終了判定</summary>
		/// <returns>正常終了ならばTrue, そうでなければFalse</returns>
		public bool IsTrue(){
			return this.ex;
		}
		/// <summary>複素数判定</summary>
		/// <returns>複素数ならばTrue, そうでなければFalse</returns>
		public bool IsImage(){
			return !this.i.isZero();
		}

        /// <summary>超えない整数</summary>
        private void Floor() {
            switch (this.r.type) {
                case NumDef.Flaction:
                    if (this.r.sign) this.r.n[0] /= this.r.d[0];
                    else this.r.n[0] = (ulong)Math.Ceiling((double)this.r.n[0] / (double)this.r.d[0]);
                    this.r.d[0] = 1;
                    break;
                case NumDef.Decimal:
                    if (this.r.sign) this.r.n[0] = (ulong)Math.Floor(this.r.f[0]);
                    else this.r.n[0] = (ulong)Math.Ceiling(Math.Abs(this.r.f[0]));
                    this.r.d[0] = 1;
                    break;
            }
            this.r.type = NumDef.Integer;
        }
        
        /// <summary>絶対値</summary>
        private void Abs() {
        	if (!this.IsImage()) {
        		switch (this.r.type) {
        			case NumDef.Integer:
        			case NumDef.Flaction:
        				this.r.sign = true;
        				break;
        			case NumDef.Decimal:
        				this.r.f[0] = Math.Abs(this.r.f[0]);
        				this.r.sign = true;
        				break;
        		}
        	} else {
        		double db = this.r.GetDouble();
        		double dc = this.i.GetDouble();
        		db = db * db + dc * dc;
        		db = Math.Sqrt(db);
        		this.r = new MNum(db.ToString());
        		this.i = new MNum("0");
        	}
        }

		/// <summary>加算</summary>
		/// <param name="a">加算するMCalc</param>
		public void Add(MCalc a) {
			this.r.OperateAdd(a.r);
			this.i.OperateAdd(a.i);
		}

		/// <summary>乗算</summary>
		/// <param name="a">乗算するMCalc</param>
		public void Mul(MCalc a) {
			if (this.IsImage() || a.IsImage()) {

				MNum ma = (MNum)this.r.Clone();
				MNum mb = (MNum)this.i.Clone();

				// 実部
				this.r.OperateMul(a.r);
				mb.OperateMul(a.i);
				mb.OperateMul(new MNum("-1"));
				this.r.OperateAdd(mb);

				// 虚部
				this.i.OperateMul(a.r);
				ma.OperateMul(a.i);
				this.i.OperateAdd(ma);
			} else {
				// 実数×実数
				this.r.OperateMul(a.r);
			}
		}

		/// <summary>減算</summary>
		/// <param name="a">減算するMCalc</param>
		public void Sub(MCalc a) {
			a.Mul(new MCalc("-1"));
			this.Add(a);
		}

		/// <summary>除算</summary>
		/// <param name="a">除算するMCalc</param>
		public void Div(MCalc a) {
			if (!a.IsImage()) {
				// 除算部分が実数
				a.r.Inverse();
			} else {
				// 除算部分が虚数
				MNum mc = (MNum)a.r.Clone();
				MNum md = (MNum)a.i.Clone();
				mc.OperateMul(mc);
				md.OperateMul(md);
				mc.OperateAdd(md);
				mc.Inverse();
				a.r.OperateMul(mc);
				a.i.OperateMul(mc);
				a.i.OperateMul(new MNum("-1"));
			}
			this.Mul(a);
		}

		/// <summary>商</summary>
		/// <param name="a">除算するMCalc</param>
		public void Quo(MCalc a) {
			if (this.r.type == NumDef.Integer && a.r.type == NumDef.Integer ) {
				this.r.n[0] /= a.r.n[0];
				this.r.sign ^= !a.r.sign;
			} else {
				this.Div(a);
			}
		}
		
		/// <summary>余り</summary>
		/// <param name="a">剰余するMCalc</param>
		public void Mod(MCalc a) {
            this.r.OperateMod(a.r);
		}

		/// <summary>三角関数</summary>
        /// <param name="k">適用する三角関数の種類</param>
		public void Tri(TriDef k) {
			if (!this.IsImage()) {
				this.r.OperateTri(k);
        	}
		}

        /// <summary>ラジアンを取得</summary>
        /// <returns>ラジアン値</returns>
        public double GetRadius() {
    		double r = this.r.GetDouble();
    		double i = this.i.GetDouble();
    		return Math.Atan2(i, r);
        }

        /// <summary>自然対数関数</summary>
		/// <remarks>z = x+yi とすると、log(z) = log|z| + atan(y/x)i</remarks>
		public void Log() {
			if (( this.r.GetDouble() > 0 ) && !this.IsImage() ) {
				this.r.OperateLog();
			} else {
				MCalc ma = (MCalc)this.Clone();
				ma.Abs();
				ma.r.OperateLog();
				double rd = this.GetRadius();
				this.r = (MNum)ma.r.Clone();
				this.i = new MNum(rd.ToString());
			}
		}

		/// <summary>対数関数</summary>
		/// <remarks>z = x+yi とすると、log(z) = log|z| + atan(y/x)i</remarks>
		public void Log(MCalc MI) {
			this.Log();
			MI.Log();
			this.Div(MI);
		}
	}
}
