﻿/*
 * Created by SharpDevelop.
 * User: munet
 * Date: 2005/10/27
 * Time: 21:04
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Drawing;
using System.Windows.Forms;

using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Runtime.InteropServices;

namespace Mumed {

	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form {
		private System.Windows.Forms.ContextMenu CmsCalc;
		private System.Windows.Forms.MenuItem CmsCalcFgcolor;
		private System.Windows.Forms.MenuItem CmsCalcFont;
		private System.Windows.Forms.MenuItem CmsCalcSave;
		private System.Windows.Forms.MenuItem CmsCalcBgcolor;
		private System.Windows.Forms.TextBox TxtCalc;
		private System.Windows.Forms.Button BtnCustomise;

        private string curdir;
		private string iniMCalc;
        private Point cmsPoint;

        /// <summary>スタートアップフォーム</summary>
        /// <returns></returns>
		public MainForm() {

			// The InitializeComponent() call is required for Windows Forms designer support.
			InitializeComponent();

			curdir   = Directory.GetCurrentDirectory();
			iniMCalc = curdir + "\\iniMCalc.dat";

			// MCalc初期設定呼び出し
			if ( File.Exists(iniMCalc) ) {
				StreamReader r = new StreamReader(iniMCalc, Encoding.GetEncoding("UTF-8"));
				StringBuilder sb = new StringBuilder();

                string sb_tmp, sb_tmp2;
                string fontname = "MS UI Gothic";
                byte fontstyle = 0;
                float fontsize = 12.0F;
                int selstart = 0, sellength = 0;
                bool readstate = true;

                sb_tmp = r.ReadLine();
                while (sb_tmp != null) {
                    sb_tmp2 = sb_tmp.Substring(sb_tmp.IndexOf('=')+1).Trim();

                    if (readstate) {
                        // カスタマイズ項目の設定
                        if (sb_tmp.StartsWith("BackColor")) TxtCalc.BackColor = Color.FromArgb(Int32.Parse(sb_tmp2));
                        else if (sb_tmp.StartsWith("ForeColor")) TxtCalc.ForeColor = Color.FromArgb(Int32.Parse(sb_tmp2));
                        else if (sb_tmp.StartsWith("FontName")) fontname = sb_tmp2;
                        else if (sb_tmp.StartsWith("FontSize")) fontsize = Single.Parse(sb_tmp2);
                        else if (sb_tmp.StartsWith("FontStyle")) fontstyle = Byte.Parse(sb_tmp2);
                        else if (sb_tmp.StartsWith("SaveState")) CmsCalcSave.Checked = Boolean.Parse(sb_tmp2);
                        else if (sb_tmp.StartsWith("WindowX")) this.Width = Int32.Parse(sb_tmp2);
                        else if (sb_tmp.StartsWith("WindowY")) this.Height = Int32.Parse(sb_tmp2);
                        else if (sb_tmp.StartsWith("SelectionStart")) selstart = Int32.Parse(sb_tmp2);
                        else if (sb_tmp.StartsWith("SelectionLength")) sellength = Int32.Parse(sb_tmp2);
                        else if (sb_tmp.StartsWith("MCalcStateShownBelow")) readstate = false;
                        // 次の行を読む
                        sb_tmp = r.ReadLine();
                    } else {
                        // テキスト領域リカバリ
                        sb.Append(sb_tmp);
                        // 次の行を読む
                        sb_tmp = r.ReadLine();
                        if (!readstate && (sb_tmp != null))
                            sb.Append("\r\n");
                    }

                }
                r.Close();

                TxtCalc.Font= new Font(fontname, fontsize,
                                       (FontStyle)fontstyle,
                                       GraphicsUnit.Point,
                                       ((System.Byte)(128)));

                if (!readstate) {
                    TxtCalc.Text = sb.ToString();
                    TxtCalc.SelectionStart = selstart;
                    TxtCalc.SelectionLength = sellength;
		            BtnCustomise.Location = new Point(this.Size.Width - 32, 8);
                    TxtCalc.Width = this.Size.Width - 16;
                    TxtCalc.Height = this.Size.Height - 58;
                }
			}
		}
		
        /// <summary>Main()</summary>
        /// <param name="args">引数</param>
		[STAThread]
		public static void Main(string[] args)
		{
			Application.Run(new MainForm());
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
			this.BtnCustomise = new System.Windows.Forms.Button();
			this.TxtCalc = new System.Windows.Forms.TextBox();
			this.CmsCalcBgcolor = new System.Windows.Forms.MenuItem();
			this.CmsCalcSave = new System.Windows.Forms.MenuItem();
			this.CmsCalcFont = new System.Windows.Forms.MenuItem();
			this.CmsCalcFgcolor = new System.Windows.Forms.MenuItem();
			this.CmsCalc = new System.Windows.Forms.ContextMenu();
			this.SuspendLayout();
			// 
			// BtnCustomise
			// 
			this.BtnCustomise.Location = new System.Drawing.Point(264, 8);
			this.BtnCustomise.Name = "BtnCustomise";
			this.BtnCustomise.Size = new System.Drawing.Size(24, 24);
			this.BtnCustomise.TabIndex = 1;
			this.BtnCustomise.Text = "▼";
			this.BtnCustomise.UseCompatibleTextRendering = true;
			this.BtnCustomise.Click += new System.EventHandler(this.BtnCustomise_Click);
			// 
			// TxtCalc
			// 
			this.TxtCalc.ImeMode = System.Windows.Forms.ImeMode.Off;
			this.TxtCalc.Location = new System.Drawing.Point(8, 32);
			this.TxtCalc.Multiline = true;
			this.TxtCalc.Name = "TxtCalc";
			this.TxtCalc.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.TxtCalc.Size = new System.Drawing.Size(280, 216);
			this.TxtCalc.TabIndex = 0;
			this.TxtCalc.KeyDown += new System.Windows.Forms.KeyEventHandler(this.TxtCalc_KeyDown);
			// 
			// CmsCalcBgcolor
			// 
			this.CmsCalcBgcolor.Index = 2;
			this.CmsCalcBgcolor.Text = "背景色の設定";
			this.CmsCalcBgcolor.Click += new System.EventHandler(this.CmsCalcBgcolor_Click);
			// 
			// CmsCalcSave
			// 
			this.CmsCalcSave.Index = 0;
			this.CmsCalcSave.Text = "終了時に状態を保存";
			this.CmsCalcSave.Click += new System.EventHandler(this.CmsCalcSave_Click);
			// 
			// CmsCalcFont
			// 
			this.CmsCalcFont.Index = 1;
			this.CmsCalcFont.Text = "フォントの設定";
			this.CmsCalcFont.Click += new System.EventHandler(this.CmsCalcFont_Click);
			// 
			// CmsCalcFgcolor
			// 
			this.CmsCalcFgcolor.Index = 3;
			this.CmsCalcFgcolor.Text = "前景色の設定";
			this.CmsCalcFgcolor.Click += new System.EventHandler(this.CmsCalcFgcolor_Click);
			// 
			// CmsCalc
			// 
			this.CmsCalc.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
									this.CmsCalcSave,
									this.CmsCalcFont,
									this.CmsCalcBgcolor,
									this.CmsCalcFgcolor});
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(296, 254);
			this.Controls.Add(this.BtnCustomise);
			this.Controls.Add(this.TxtCalc);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MinimumSize = new System.Drawing.Size(128, 160);
			this.Name = "MainForm";
			this.Text = "お節介屋";
			this.Closed += new System.EventHandler(this.Mumed_Closed);
			this.Resize += new System.EventHandler(this.Mumed_Resize);
			this.ResumeLayout(false);
			this.PerformLayout();
		}
		#endregion

		/// <summary>テキストボックスの現在の行を取得する</summary>
		/// <returns>現在の行</returns>
		int TxtCalc_GetCurrentRows() {
		    string  s = "" ;
		    try   { s = TxtCalc.Text.Substring(0, TxtCalc.SelectionStart) ; }
		    catch { s = TxtCalc.Text ; }

			return Regex.Matches(s, "\n").Count;
		}

		/// <summary>テキストボックスでキーを押したかを判定する</summary>
		void TxtCalc_KeyDown(object sender, System.Windows.Forms.KeyEventArgs ke) {
			if ( ke.Control == true && ke.KeyCode == Keys.E ) {
				int c_rows = TxtCalc_GetCurrentRows();
				int c_leng = TxtCalc.Lines.Length;
				int c_curs;
				for ( c_curs = TxtCalc.SelectionStart; ;c_curs++) {
					if (c_curs >= TxtCalc.Text.Length) break;
					if (TxtCalc.Text[c_curs] != '\n') break;
				}
				c_curs++;

				if ( TxtCalc.Text.Length > 0 && TxtCalc.Lines[c_rows][0] != ';') {
					// 計算します
					MCalc MI = Mumed.MCalc.AnalysisLisp(TxtCalc.Lines[c_rows]);

					if ( MI.IsTrue() ) {
						// テキスト設定
						StringBuilder sb = new StringBuilder();
	
						for ( int i = 0; i <= c_rows; i++) {
							sb.Append(TxtCalc.Lines[i]);
							sb.Append("\r\n");
						}
						sb.Append(MI.ToString());
						sb.Append("\r\n");
						for ( int i = c_rows + 1; i < ( c_leng - 1 ); i++) {
							sb.Append(TxtCalc.Lines[i]);
							sb.Append("\r\n");
						}

						// TxtCalcテキストボックス更新
						TxtCalc.Text = sb.ToString();
						TxtCalc.SelectionStart = c_curs;
						TxtCalc.SelectionLength = 0;
						TxtCalc.ScrollToCaret();
					}
				}
				//MessageBox.Show(e.ToString());
				//MessageBox.Show(TxtCalc.Lines[0]);
			}
		}

        /// <summary>カスタマイズボタンを左クリック</summary>
        private void BtnCustomise_Click(object sender, EventArgs e) {
            cmsPoint = PointToClient(Cursor.Position);
            this.CmsCalc.Show(this, cmsPoint);
        }

        /// <summary>カスタマイズボタン-保存設定</summary>
        private void CmsCalcSave_Click(object sender, EventArgs e) {
			this.CmsCalcSave.Checked = !this.CmsCalcSave.Checked;
            this.CmsCalc.Show(this, cmsPoint);
        }

        /// <summary>カスタマイズ-フォント設定</summary>
        private void CmsCalcFont_Click(object sender, EventArgs e) {
            FontDialog fdg = new FontDialog();

            fdg.Font = TxtCalc.Font;
            fdg.MaxSize = 24;
            fdg.MinSize = 6;
            fdg.ShowEffects = false;
            fdg.AllowVerticalFonts = false;

            if (fdg.ShowDialog() == DialogResult.OK)
                TxtCalc.Font = fdg.Font;
            fdg.Dispose();
        }

        /// <summary>カスタマイズ-背景色</summary>
        private void CmsCalcBgcolor_Click(object sender, EventArgs e) {
            ColorDialog cdg = new ColorDialog();

            cdg.Color = TxtCalc.BackColor;
            cdg.FullOpen = true;
            cdg.AnyColor = true;
            cdg.SolidColorOnly = true;
            cdg.ShowHelp = false;
            if (cdg.ShowDialog() == DialogResult.OK)
                TxtCalc.BackColor = cdg.Color;
            cdg.Dispose();
        }

        /// <summary>カスタマイズ-前景色</summary>
        private void CmsCalcFgcolor_Click(object sender, EventArgs e) {
            ColorDialog cdg = new ColorDialog();

            cdg.Color = TxtCalc.ForeColor;
            cdg.FullOpen = true;
            cdg.AnyColor = true;
            cdg.SolidColorOnly = true;
            cdg.ShowHelp = false;
            if (cdg.ShowDialog() == DialogResult.OK)
                TxtCalc.ForeColor = cdg.Color;
            cdg.Dispose();
        }

        /// <summary>フォームのリサイズ</summary>
        void Mumed_Resize(object sender, System.EventArgs e) {
            BtnCustomise.Location = new Point(this.Size.Width - 32, 8);
            TxtCalc.Width = this.Size.Width - 16;
            TxtCalc.Height = this.Size.Height - 58;
        }
        /// <summary>糸冬</summary>
        void Mumed_Closed(object sender, System.EventArgs e) {
            StreamWriter w = new StreamWriter(iniMCalc, false, Encoding.GetEncoding("UTF-8"));

            w.WriteLine("BackColor = " + TxtCalc.BackColor.ToArgb().ToString());
            w.WriteLine("ForeColor = " + TxtCalc.ForeColor.ToArgb().ToString());
            w.WriteLine("FontName = " + TxtCalc.Font.Name);
            w.WriteLine("FontSize = " + TxtCalc.Font.Size.ToString());
            int style = (int)(FontStyle.Regular);
            style += (int)(TxtCalc.Font.Bold ? FontStyle.Bold : 0);
            style += (int)(TxtCalc.Font.Italic ? FontStyle.Italic : 0);
            w.WriteLine("FontStyle = " + style.ToString());

            if (CmsCalcSave.Checked == true) {
                w.WriteLine("SaveState = " + true.ToString());
                if ( this.WindowState == FormWindowState.Normal ) {
	                w.WriteLine("WindowX = " + this.Width.ToString());
	                w.WriteLine("WindowY = " + this.Height.ToString());
                }
                w.WriteLine("SelectionStart = " + TxtCalc.SelectionStart.ToString());
                w.WriteLine("SelectionLength = " + TxtCalc.SelectionLength.ToString());
                w.WriteLine("MCalcStateShownBelow");
                int c_leng = TxtCalc.Lines.Length;
                for (int i = 0; i < c_leng; i++) {
                    w.WriteLine(TxtCalc.Lines[i]);
                }
            } else {
                w.WriteLine("SaveState = " + false.ToString());
            }
            w.Close();
        }        
    }
}
